/* "Bit Compressor", ineffective version, written by Marcin Balcerzak */
#include <iostream>
#include <cstdio>
#include <string>
#include <math.h>


using namespace std;

class mystring{
	private:
		string s;
	public:
		mystring(string x){ s=x; }
		mystring(const mystring& x){ s=x.s; }		
		mystring(){ s=""; }
		int size(){ return s.size(); }
		char& operator[](int elem){	return s[elem]; }
		mystring operator+(mystring ms){
			mystring res;
			res.s=res.s+this->s;
			res.s=res.s+ms.s;
			return res;
		}
		mystring operator+(string ms){
			mystring res;
			res.s=res.s+this->s;
			res.s=res.s+ms;
			return res;
		}
		mystring operator+(int n){
			string ms=""+n;
			mystring res;
			res.s=res.s+this->s;
			res.s=res.s+ms;
			return res;
		}		
		void operator=(const string& ms){
			this->s=ms;
		}		
		void operator=(const mystring& ms){
			this->s=ms.s;
		}	
		bool operator==(mystring ms){ return this->s==ms.s; }	
		/* increases by one the binary given as a string */
		mystring inc(){
			mystring res=*this;
			//mystring pom=string("1");
			int p=1;
			for(int i=res.size()-1; i>=0; i--){
				if(p==0) break;
				else if(res[i]=='0') { res[i]='1'; p=0; }
				else res[i]='0'; 
			}
			if(p==1) res=mystring("1")+res;
			*this=res;
			return res;
		}	
		string gets(){ return s; }	
};

char c;
mystring code(""); /* compressed mesage */
int L, N, length, maxm, result, casenumber;
mystring mw("0"); /* uncompressed message */
string pom="";

/* counts number of 1's in the string */
inline int countOnes(mystring s){
	int res=0;
	for(int i=0; i<s.size(); i++) if(s[i]=='1') res++;
	return res;
}

/* converts decimal to binary */
mystring binary(int n) {
	mystring res;
	int d=n;
	int p;
	while(d>0){
		p=d%2;
		if (p==0) res=res+"0"; else res=res+"1";
		d=d/2;
	}
	mystring res2;
	for(int i=res.size()-1; i>=0; i--)  if(res[i]=='0') res2=res2+"0";
		else res2=res2+"1";
	return res2;
}

inline mystring compress(mystring s){
	mystring res;
	int i=0;
	int j=0;
	while(i<s.size()){
		if(s[i]=='0') { res=res+"0"; i++; }
		else if((i<s.size()-1)&&(s[i+1]=='1')){
			j=0;
			while((i<s.size())&&(s[i]=='1')) { j++; i++; }
			res=res+binary(j);
		}
		else { res=res+"1"; i++; }
	}
	return res;
}

int main () {
scanf ("%d%d", &L, &N);
casenumber=0;
while ((L!=0)||(N!=0)) {
	casenumber++;
	result=0;
	scanf ("%c", &c);
	code=""; pom=""; cin>>pom; code=pom;
	mw="0";
	while(mw.size()<L) mw.inc();
	while(mw.size()==L){
		if((countOnes(mw)==N)&&(compress(mw)==code)) result++;
		mw.inc();
	}
	switch (result) {
		case 0: printf ("Case #%d: NO\n", casenumber); break;
		case 1: printf ("Case #%d: YES\n", casenumber); break;
		default: printf ("Case #%d: NOT UNIQUE\n", casenumber); break;
	}
	scanf ("%d%d", &L, &N);
	}
return 0;
}
